<template>
  <q-layout view="hHh lpR fFf">
    <q-page-container>
      <q-header elevated>

        <q-header elevated>
          <Toolbar :pageTitle="conference.Name" :eventlogOffset="true" :overrideBack="'/'" />
        </q-header>

      </q-header>

      <q-page>
        <div class="joining-instructions-public"
          v-if="conference.Privacy && (conference.Privacy.IsPublic || conference.Privacy.AcceptContacts)">
          <p v-html="$t('conference.inbound_instructions', [conference.DropCallJoinNumber, conference.PIN])"></p>
        </div>
        <div class="joining-instructions-private" v-else>
          <p v-html="$t('conference.private_instructions', [conference.DropCallJoinNumber, conference.PIN])"></p>
        </div>

        <ActiveConferenceToolbar :conferenceParticipants="conference.Participants"
        :hasCapacity="hasCapacity" :maxCapacity="conference.MaxCapacity"
          :conferenceStart="conference.ActualStart" v-on:addparticipant="showAddParticipantDialog = true"
          v-on:addPoll="requestCreatePollDialog" v-on:endcall="requestEndCall" class="pl-toolbar" />


        <div class="join-buttons">

          <div class="join-button-container" style="float: left;">
            <div style="float: right">

              <WebRtc :class="[rtcSpeaking ? 'host-speaking' : 'host-not-speaking']"
                style="float:right; margin-right: 10px; margin-left:10px;" :getDetailsAction="requestWSDetails"
                :callWhenMounted="this.$route.query.joinRtc === 'true'" />

              <p v-if="rtcInCall" style="text-align: center"> {{ $t("conference.microphone") }}
                <q-toggle @input="handleHostRtcMute" :value="!rtcCallerObj.Muted" :disable="rtcMuteLoading" size="lg"
                  :color="rtcCallerObj.Muted ? 'red' : 'green'" checked-icon="mic" unchecked-icon="mic_off" />
              </p>
            </div>
          </div>

          <div class="join-button-container" style="float: right;">
            <div style="float: left; margin-right:10px;">
              <div :class="[phoneSpeaking ? 'host-speaking' : 'host-not-speaking']">
                <q-btn class="join-button-size" :color="hostPhoneInCall ? 'white bg-red' : 'white bg-green'"
                  :disable="hostPhoneConnecting" @click="callHost">
                  <div class="button-visual">
                    <q-spinner v-if="hostPhoneConnecting" />
                    <q-icon v-else name="phone" />
                  </div>
                  <div class="button-txt">
                    {{
  hostPhoneInCall? $t("conference.phone_joined"): hostPhoneConnecting ?
  $t("conference.phone_joining"): $t("conference.phone_join")
                    }}
                  </div>
                </q-btn>
              </div>
              <p v-if="hostPhoneInCall" style="text-align: center"> {{ $t("conference.microphone") }}
                <q-toggle @input="handleHostPhoneMute" :value="!hostPhoneObj.Muted" :disable="hostPhoneMuteLoading"
                  size="lg" :color="hostPhoneObj.Muted ? 'red' : 'green'" checked-icon="mic" unchecked-icon="mic_off" />
              </p>
            </div>
          </div>
        </div>

        <div class="call-timer" :style="{ color: callTimerColour }">
          {{ $t("conference.time_remaining", [callTimerString]) }}
        </div>

        <div v-if="conference.Agenda" class="agenda-manager row justify-center items-center">

          <div v-if="!this.currentAgenda">
            <p class="agenda-start-title"> {{ $t("conference.agenda_ready_prompt_title") }}</p>
            <p style="text-align:center"> {{ $t("conference.agenda_ready_prompt") }}</p>
            <div style="width:100%; text-align: center;">
              <q-btn style="width: 42px; margin: 0 auto;" icon="navigate_next" color="white" class="bg-purple" round
                @click="handleAdvanceAgenda">
                <q-tooltip>
                  {{ $t("conference.agenda_next", [conference.Agenda[0].Topic]) }}
                </q-tooltip>
              </q-btn>
            </div>

          </div>
          <div v-else>

            <div class="agenda-manager-content">
              <div class="agenda-manager-title" v-if="this.currentAgenda">
                {{ this.currentAgenda.Topic }}
              </div>
              <div class="timer" :style="{ color: agendaTimerColour }">
                {{ agendaTimerString }}
              </div>


              <p v-if="this.currentAgenda.Attendees" class="agenda-manager-attendees">
                <q-icon name="mic" color="green" size="16px" />
                {{ participantNames(this.currentAgenda.Attendees) }}
              </p>

            </div>

            <div class="agenda-manager-btn-container">
              <q-btn :disable="conference.Agenda.length <= conference.AgendaCurrent + 1" icon="navigate_next"
                color="white" class="bg-purple" round @click="handleAdvanceAgenda" style="float:right">
                <q-tooltip v-if="conference.Agenda.length > conference.AgendaCurrent + 1">
                  {{ $t("conference.agenda_next", [conference.Agenda[conference.AgendaCurrent + 1].Topic]) }}
                </q-tooltip>
              </q-btn>
            </div>

            <q-expansion-item icon="edit_note" :label="$t('conference.agenda_notes')"
              expand-icon-class="agenda-manager-notes-icon">
              <q-card>
                <q-card-section class="agenda-manager-notes">

                  <p v-if="this.currentAgenda.Notes">
                    {{ this.currentAgenda.Notes }}
                  </p>

                  <ul style="list-style-type: none; padding-left: 20px;">
                    <li v-for="(minute, minId) in this.currentAgenda.MinuteNotes" :key="minId"
                      style="margin-bottom:10px;">

                      <q-btn style="display: inline-block; font-size: 0.5em; margin-right: 2px;" icon="clear"
                        color="red" round @click="handleRemoveNote(minId)" />
                      {{ minute.Text }}
                    </li>
                  </ul>

                  <div style="width:100%; text-align: center;" class="row items-center">
                    <q-input class="minutes-input" color="purple" outlined v-model="notesMinutes" dense
                      :label="$t('conference.meeting_minutes')" @keyup.enter="handleAddNote()" />
                    <q-btn style="display: inline-block;" icon="add" color="white" class="bg-purple on-right" round
                      size="sm" @click="handleAddNote" />
                  </div>
                </q-card-section>
              </q-card>
            </q-expansion-item>

          </div>


        </div>

        <div v-if="activePoll" style="text-align:center">
          <PollView :rawData="activePoll" :showTitle="true" class="poll" />
          <q-btn icon="stop_circle" color="red" size="sm" :label="$t('poll.end')" @click="handleEndPoll" />
        </div>

        <div class="pl-fullpage">
          <ParticipantList :title="$t('conference.in_call')" :participants="activeParticipants"
            :usersPhone="usersPhone" />
          <!-- <q-separator /> -->
          <ParticipantList :title="$t('conference.waiting_to_join')" @callParticipant="handleCallParticipant"
            :hasCapacity="hasCapacity" :participants="notYetActive" :usersPhone="usersPhone" />
          <!-- <q-separator /> -->
          <ParticipantList :title="$t('conference.no_longer_in_call')" :participants="wereActive"
          :hasCapacity="hasCapacity" @callParticipant="handleCallParticipant" :usersPhone="usersPhone" :showcallall="hasCapacity" />
          <q-page-sticky position="bottom-right" class="q-ma-sm">

            <q-btn icon="mic_off" color="white" class="bg-orange on-left" round size="lg" @click="handleMuteAll">
              <q-tooltip>
                {{ $t("active_conference_toolbar.mute_all") }}
              </q-tooltip>
            </q-btn>

            <q-btn icon="mic" color="white" class="bg-orange" size="lg" round @click="handleUnmuteAll">
              <q-tooltip>
                {{ $t("active_conference_toolbar.unmute_all") }}
              </q-tooltip>
            </q-btn>

          </q-page-sticky>
          <q-dialog v-model="showAddParticipantDialog">
            <AddParticipantForm :user="user" :conference="conference" :addParticipant="handleAddParticipant" />
          </q-dialog>

          <q-dialog v-model="showAddPollDialog">
            <AddPollForm :user="user" :conference="conference" :addPoll="handleAddPoll" />
          </q-dialog>

        </div>
      </q-page>
    </q-page-container>
    <q-drawer v-model="showEventLog" show-if-above side="right" :width="300" :breakpoint="840" elevated
      content-class="">
      <EventLogDialog :events="conference.Events" :hostName="hostName" />
    </q-drawer>
  </q-layout>
</template>
<script>
import { functions, db, auth } from "../firebase";
import PollView from "../components/PollView.vue";
import ParticipantList from "../components/ParticipantList.vue";
import AddParticipantForm from "../components/AddParticipantForm.vue";
import AddPollForm from "../components/AddPollForm.vue";
import ActiveConferenceToolbar from "../components/ActiveConferenceToolbar.vue";
import EventLogDialog from "../components/EventLogDialog.vue";
import Toolbar from "../components/Toolbar.vue";
import WebRtc from "../components/WebRtcCaller.vue";
import moment from 'moment';

export default {
  data()
  {
    return {
      conference: { loading: true },
      user: { loading: true },
      showAddParticipantDialog: false,
      showAddPollDialog: false,
      showEventLog: false,
      rtcCallerObj: null,
      rtcMuteLoading: false,
      hostPhoneObj: null,
      hostPhoneMuted: false,
      hostPhoneMuteLoading: false,
      notesMinutes: "",
      agendaTimerString: '--:--',
      callTimerString: '--:--',
      timerInterval: 0,
      agendaTimerColour: '#757575',
      callTimerColour: '#757575'
    };
  },
  beforeDestroy()
  {
    clearInterval(this.timerInterval)
  },
  created()
  {
    this.$rtdbBind("conference", db.ref("Conferences/Live").child(this.$route.params.id)).then(() =>
    {
      this.startTimer();
    });
    this.$rtdbBind("user", db.ref(`Users/${auth.currentUser.uid}`)).then(() =>
    {
      this.$rtdbBind("hostPhoneObj", db.ref(`Conferences/Live/${this.$route.params.id}/Participants/${this.user.Phone}`));
    });
    this.$rtdbBind("rtcCallerObj", db.ref(`Conferences/Live/${this.$route.params.id}/Participants/1000`));
  },
  watch: {
    conference(newConf)
    {
      if (!newConf.Name)
      {
        console.log('Conference has been moved or deleted, return to homepage');
        this.$router.replace({
          name: 'Dashboard'
        });
      }
    },
    hostPhoneObj(newHost, oldHost)
    {
      if (newHost && oldHost && newHost.Muted != oldHost.Muted)
      {
        this.hostPhoneMuteLoading = false;
      }
    },
  },
  computed: {
    hasCapacity()
    {
      // is the number of participants currently in call + host less than the max capacity?
      return this.conference.MaxCapacity - (Object.keys(this.activeParticipants).length + 1) > 0
    },
    timeRemainingMessage()
    {
      let diff = moment(this.conference.ScheduledEnd).diff(moment(), 'seconds')
      if (diff <= 0)
      {
        return "Ending call..."
      }
      else if (diff > 60)
      {
        return "This call will end in " + diff / 60 + " minutes";
      }
      return "This call will end in " + diff + " seconds";
    },
    currentAgenda()
    {
      if (typeof this.conference.AgendaCurrent === 'undefined' || this.conference.AgendaCurrent == -1)
      {
        return null;
      }
      return this.conference.Agenda[this.conference.AgendaCurrent];
    },
    rtcSpeaking()
    {
      return this.rtcInCall && this.rtcCallerObj.SessionData.InCall && !this.rtcCallerObj.Muted && this.rtcCallerObj.Speaking;
    },
    phoneSpeaking()
    {
      return this.hostPhoneInCall && this.hostPhoneObj.SessionData.InCall && !this.hostPhoneObj.Muted && this.hostPhoneObj.Speaking;
    },
    rtcInCall()
    {
      return this.rtcCallerObj && this.rtcCallerObj.SessionData && this.rtcCallerObj.SessionData.InCall;
    },
    hostName()
    {
      if (this.hostPhoneObj) return this.hostPhoneObj.Name;
      return this.$t('loading');
    },
    hostPhoneConnecting()
    {
      return this.hostPhoneObj && (this.hostPhoneObj.Status == 'Queued' || this.hostPhoneObj.Status == 'Dialling' || this.hostPhoneObj.Status == 'Consenting')
    },
    hostPhoneInCall()
    {
      return this.hostPhoneObj && (this.hostPhoneObj.Status == 'Active' || (this.hostPhoneObj.SessionData && this.hostPhoneObj.SessionData.InCall));
    },
    // Participants currently in the call
    // Should be ordered by priority: hand up, moderator, default
    activeParticipants()
    {
      if (this.conference == undefined) return;
      let allActive = this.filterParticipants(this.conference.Participants, 'Status', ["Active"]);
      let handsUp = this.filterParticipants(allActive, 'HandUp', [true]);
      let allMods = this.filterParticipants(allActive, 'Moderator', [true]);

      // remove duplicates between sets, prioritising hands up
      for (let p in handsUp) 
      {
        delete allActive[p];
        delete allMods[p]
      }
      for (let p in allMods) delete allActive[p];

      // combine sets in order
      return Object.assign({}, handsUp, Object.assign({}, allMods, allActive));
    },
    // return the most recent poll
    activePoll()
    {
      if (!this.conference.Polls) return null;
      let keys = Object.keys(this.conference.Polls);
      let lastPoll = this.conference.Polls[keys[keys.length - 1]];
      return lastPoll.Open ? lastPoll : null;
    },
    // The set of participants who have not
    // yet been active
    notYetActive()
    {
      if (this.conference == undefined) return;
      return this.filterParticipants(this.conference.Participants, 'Status', [
        "Invited",
        "Queued",
        "Dialling",
        "Consenting",
        "WAITING_RETRY",
        "RETRYING"
      ]);
    },
    // The set of participants who have been
    // active, but currently are not
    wereActive()
    {
      if (this.conference == undefined) return;
      return this.filterParticipants(this.conference.Participants, 'Status', [
        "Hangup",
        "Timeout",
        "ERROR"
      ]);
    },
    usersPhone()
    {
      return this.user.Phone || "";
    },
  },
  methods: {
    callHost()
    {
      this.handleCallParticipant(this.user.Phone)
    },
    async handleHostRtcMute() 
    {
      const fbMuteUnMuteParticipant = functions.httpsCallable(
        "muteUnmuteParticipant"
      );

      if (!this.rtcCallerObj) 
      {
        console.log("Can't find host in call");
        return;
      }

      this.rtcMuteLoading = true;

      await fbMuteUnMuteParticipant({
        ConferenceId: this.$route.params.id,
        ParticipantNumber: '1000',
        Uuid: this.rtcCallerObj.SessionData.CallUuid,
        ConfMemberId: this.rtcCallerObj.SessionData.ConfMemberId,
        Muted: this.rtcCallerObj.Muted === undefined ? true : !this.rtcCallerObj.Muted,
      });

      this.rtcMuteLoading = false;
    },
    async handleHostPhoneMute() 
    {
      const fbMuteUnMuteParticipant = functions.httpsCallable(
        "muteUnmuteParticipant"
      );

      if (!this.hostPhoneObj) 
      {
        console.log("Can't find host in call");
        return;
      }

      this.hostPhoneMuteLoading = true;

      await fbMuteUnMuteParticipant({
        ConferenceId: this.$route.params.id,
        ParticipantNumber: this.user.Phone,
        Uuid: this.hostPhoneObj.SessionData.CallUuid,
        ConfMemberId: this.hostPhoneObj.SessionData.ConfMemberId,
        Muted: this.hostPhoneObj.Muted === undefined ? true : !this.hostPhoneObj.Muted,
      });

      this.hostPhoneMuteLoading = false;
    },
    async handleRemoveNote(noteId)
    {
      this.$q.loading.show();
      try
      {
        const fbFunction = functions.httpsCallable("deleteMinuteNoteFromAgendaItem");
        await fbFunction(
          {
            ConferenceId: this.$route.params.id,
            AgendaItemIndex: this.conference.AgendaCurrent,
            NoteId: noteId
          });
      }
      catch (error)
      {
        console.log(error)
      }
      finally
      {
        this.$q.loading.hide();
      }
    },
    async handleAddNote()
    {
      this.$q.loading.show();
      try
      {
        const fbFunction = functions.httpsCallable("addMinuteNoteToAgendaItem");
        await fbFunction(
          {
            ConferenceId: this.$route.params.id,
            AgendaItemIndex: this.conference.AgendaCurrent,
            Text: this.notesMinutes
          });
        this.notesMinutes = "";
      }
      catch (error)
      {
        console.log(error)
      }
      finally
      {
        this.$q.loading.hide();
      }
    },
    async handleAdvanceAgenda()
    {
      this.$q.loading.show();
      try
      {
        const fbFunction = functions.httpsCallable("advanceAgenda");
        await fbFunction(
          {
            ConferenceId: this.$route.params.id
          });
      }
      catch (error)
      {
        console.log(error)
      }
      finally
      {
        this.$q.loading.hide();
      }
    },
    onInterval(target, firstWarningMins, secondWarningMins)
    {
      let remainingMillis = target - Date.now();
      let toRet = {}

      if (remainingMillis < 1000) 
      {
        toRet.TimeString = "00:00";
        toRet.Colour = 'red';
      }
      else
      {
        let minutes = Math.floor(remainingMillis / 60000);
        let seconds = ((remainingMillis % 60000) / 1000).toFixed(0);

        toRet.Colour = minutes < secondWarningMins ? 'red' : minutes < firstWarningMins ? 'orange' : '#757575';
        toRet.TimeString = (minutes < 10 ? "0" + minutes : minutes) + ":" + (seconds < 10 ? "0" + seconds : seconds)
      }
      return toRet;
    },
    startTimer()
    {
      this.timerInterval = setInterval(() =>
      {
        let callTimerRes = this.onInterval(this.conference.ScheduledEnd, 5, 2);
        this.callTimerColour = callTimerRes.Colour;
        this.callTimerString = callTimerRes.TimeString;

        if (!this.currentAgenda || !this.currentAgenda.Started) return;
        let agendaTimerRes = this.onInterval(this.currentAgenda.Started + this.currentAgenda.Minutes * 60 * 1000, 1, 0);
        this.agendaTimerColour = agendaTimerRes.Colour;
        this.agendaTimerString = agendaTimerRes.TimeString;

      }, 1000);
    },
    requestEndCall() 
    {
      console.log("Requesting ending the call");
      this.$q
        .dialog({
          title: this.$t("confirm"),
          message: this.$t("conference.end_conference_confirmation"),
          ok: { label: this.$t("confirm"), flat: true, color: "negative" },
          cancel: { label: this.$t("cancel"), flat: true, color: "grey-7" },
        })
        .onOk(async () =>
        {
          this.$q.loading.show();
          const fbFunction = functions.httpsCallable("endConference");
          await fbFunction({ ConferenceId: this.$route.params.id }).then(() =>
            this.$router.replace({
              name: "Dashboard",
            })
          );
          this.$q.loading.hide();
        });
    },
    async requestWSDetails()
    {
      const fbFunction = functions.httpsCallable("getWSinfo");
      return (await fbFunction({
        ConferenceId: this.$route.params.id
      })).data;
    },
    requestCreatePollDialog()
    {
      if (this.activePoll)
      {
        this.$q
          .dialog({
            title: this.$t("conference.replace_poll_title"),
            message: this.$t("conference.replace_poll"),
            ok: { label: this.$t("confirm"), flat: true, color: "negative" },
            cancel: { label: this.$t("cancel"), flat: true, color: "grey-7" },
          })
          .onOk(async () =>
          {
            this.handleEndPoll();
            this.showAddPollDialog = true
          });
      } else
      {
        this.showAddPollDialog = true;
      }
    },
    handleEndPoll()
    {
      const fbFunction = functions.httpsCallable("endPoll");
      fbFunction({
        ConferenceId: this.$route.params.id
      });
    },
    handleMuteAll()
    {
      const fbFunction = functions.httpsCallable("muteUnmuteConference");
      fbFunction({
        ConferenceId: this.$route.params.id,
        Mute: true,
      });
    },
    handleUnmuteAll()
    {
      const fbFunction = functions.httpsCallable("muteUnmuteConference");
      fbFunction({
        ConferenceId: this.$route.params.id,
        Mute: false,
      });
    },
    participantNames(participants)
    {
      let names = []

      participants.forEach(num =>
      {
        if (this.conference.Participants[num])
        {
          names.push(this.conference.Participants[num].Name)
        }
        else
        {
          names.push(num);
        }
      });

      return names.join(', ');
    },
    filterParticipants(confParticipants, filterField, filterValues) 
    {
      if (confParticipants == undefined) return;
      const participants = {};

      for (var phoneNumber in confParticipants)
      {
        if (phoneNumber == this.user.Phone) continue;

        for (var filterInd in filterValues)
        {
          if (confParticipants[phoneNumber][filterField] &&
            (
              confParticipants[phoneNumber][filterField] === filterValues[filterInd] ||
              (
                typeof confParticipants[phoneNumber][filterField] === "string" &&
                confParticipants[phoneNumber][filterField].includes(filterValues[filterInd])
              )
            )
          )
          {
            participants[phoneNumber] = { ...confParticipants[phoneNumber] };
            break;
          }
        }
      }

      return participants;
    },
    async handleCallParticipant(phoneNumber)
    {
      console.log("Requested to call: ", phoneNumber);
      const fbFunction = functions.httpsCallable("callParticipant");
      const response = await fbFunction({
        ConferenceId: this.$route.params.id,
        PhoneNumber: phoneNumber,
      }).catch((error) =>
      {
        this.$q.notify({
          type: "negative",
          message: error,
        });
      });
      console.log(response);
    },
    async handleAddPoll(poll)
    {
      const fbFunction = functions.httpsCallable("startPoll");
      poll.Conference = this.$route.params.id;
      this.$q.loading.show();
      await fbFunction(poll).catch((error) =>
      {
        this.$q.notify({
          type: "negative",
          message: error,
        });
      });
      this.$q.loading.hide();
      this.showAddPollDialog = false;
    },
    async handleAddParticipant(phoneNumber, participant)
    {
      console.log("handleAddParticipant", phoneNumber, participant);
      this.$q.loading.show();
      const addParticipant = functions.httpsCallable("addParticipant");
      const response = await addParticipant({
        ConferenceId: this.$route.params.id,
        PhoneNumber: phoneNumber,
        Name: participant.Name,
        Moderator: participant.Moderator,
      }).catch((error) =>
      {
        this.$q.notify({
          type: "negative",
          message: error,
        });
      });
      console.log(response);
      this.$q.loading.hide();
      this.showAddParticipantDialog = false;
    },
  },
  components: {
    ParticipantList,
    AddParticipantForm,
    AddPollForm,
    ActiveConferenceToolbar,
    EventLogDialog,
    PollView,
    Toolbar,
    WebRtc
  },
};
</script>
<style>
.join-buttons {
  width: 100%;
  display: inline-block;
  margin-top: 10px;
}

.join-button-container {
  display: block;
  width: 50%;
  padding: 3px;
}

.agenda-manager {
  display: block;
  width: 60%;
  max-width: 600px;
  min-width: 350px;
  margin: 20px auto;
  border-width: 4px;
  border-color: #b379bd;
  border-style: solid;
  border-radius: 20px;
  padding: 20px;
}

.agenda-manager-title {
  color: #9c27b0;
  font-weight: bold;
  margin-bottom: 8px;
  display: inline-block;
  width: 85%;
}

.timer {
  float: right;
  font-size: 16px;
  font-weight: bold;
}

.call-timer {
  text-align: center;
  margin: 20px;
  font-size: 16px;
  font-weight: bold;
}

.agenda-start-title {
  color: #9c27b0;
  font-weight: bold;
  text-align: center;
  margin-bottom: 8px;
  width: 100%;
}

.agenda-manager-content {
  display: inline-block;
  width: 80%;
  padding: 0px 10px;
}

.agenda-manager-notes {
  font-size: small;
  margin: 0px;
  padding: 0px 15px;
}

.agenda-manager-attendees {
  font-size: small;
  margin-bottom: 8px;
  font-style: italic;
}

.agenda-manager-btn-container {
  display: block;
  width: 50px;
  height: 100%;
  float: right;
}

.minutes-input {
  display: inline-block;
  width: 90%
}

.host-speaking {
  box-shadow: 0 0 0 5px #21BA45;
  border-radius: 2px;
}

.host-not-speaking {
  box-shadow: 0 0 0 5px transparent;
  border-radius: 2px;
}

.poll {
  margin: 20px auto 20px auto;
  width: 400px;
  max-height: 444px;
}

.joining-instructions-public,
.joining-instructions-private {
  font-size: large;
  width: 100%;
  padding: 10px;
  text-align: center;
  color: white;
  margin-top: 50px;
}

.joining-instructions-public p,
.joining-instructions-private p {
  margin-bottom: 0px;
}

.joining-instructions-public {
  background: #21BA45;
}

.joining-instructions-private {
  background: #F57C00;
}

.join-button-size {
  width: 200px;
}

.button-visual {
  margin-right: 15px;
  display: inline-block;
  width: 10%;
  height: 100%;
  padding: 3px 0;
}

.button-txt {
  display: inline-block;
  width: 70%;
  height: 100%;
  padding: 3px 0;
}

@media only screen and (max-width: 1150px) {
  .minutes-input {
    width: 85%
  }

  .agenda-manager-title {
    width: 80%;
  }
}

@media only screen and (max-width: 915px) {
  .minutes-input {
    width: 83%
  }
}

@media only screen and (max-width: 500px) {
  .q-toolbar {
    padding: 0px;
  }
}

@media only screen and (max-width: 450px) {
  .join-button-size {
    width: 140px;
  }

  .join-button-size {
    font-size: 12px;
  }

  .button-visual {
    width: 100%;
    height: 30px;
    font-size: 18px;
    margin-right: 0px;
    margin-bottom: 3px;
  }

  .button-txt {
    height: auto;
    width: 100%;
  }
}
</style>